#define MAX_QRCODE_COUNT 10

typedef std::complex<double> P;


class DetectQR{
	int width,height;
	Bitmap16 lbuf;
	Bitmap *tmp;
	Bitmap *qrimg;
	const Bitmap *srcimg;

public:
	P cp[MAX_QRCODE_COUNT*4][4];
	P p3[MAX_QRCODE_COUNT];
	int size[MAX_QRCODE_COUNT];
	int ptn_count;
	std::vector<int> pat;
	int count;

	DetectQR(Size sz): width(sz.w) , height(sz.h) {
		lbuf.create(sz.w,sz.h);
		tmp=NULL;
	}
	void settmp(Bitmap &img,Bitmap &qr) {
		tmp=&img;
		qrimg=&qr;
	}

	int detect(Bitmap &img);
	void getCode(Bitmap8 &code,int i);
	void getCode2(Bitmap8 &code,int i);
	void getQRImage(Bitmap &qr,int i);

	void getVertex(P vert[4],int i) {
		int c0=pat[i*3+0],c1=pat[i*3+1],c2=pat[i*3+2];
		vert[0] = cp[c0][0];
		vert[1] = cp[c1][0];
		vert[2] = p3[i];
		vert[3] = cp[c2][0];
	}


	int getCodeSize(int i) {
		return size[i];
	}


};
