#include <iostream>
#include <complex>
#include <map>
#include "cppfl/all.h"
#include "cppfl/capture.h"
#include "cppfl/capture2.h"
#include "cppfl/opengl.h"
#include "detect.h"
#include "GLMetaseq.h"

#include <AR/param.h>			// arParamDisp()
#include <AR/ar.h>
#include <AR/gsub.h>

using namespace std;

int decodeqr(string &s,const Bitmap8 &b);

typedef unsigned char uchar;
typedef unsigned int uint;

typedef double ARFloat;

struct QROBJ{
	QROBJ(){fail_count=0;frame_count=0;}
	P g;
	int fail_count;
	double deg;
	string str;
	int matid;
	long frame_count;
	ARFloat mat[16];
};

class MyForm : public Form {
public:
	PictureBox pic;
	DIBitmap dib;

	PictureBox pic0;
	DIBitmap bmp0;
	DIBitmap dib0;
//	DCPen *p0;

	PictureBox pic1;
	DIBitmap qrdib;
	DIBitmap qrdib_tmp;

	Capture cam;
	OpenGL gl;

	int obj_count;
	DetectQR *detector;
	vector<QROBJ> objs;
	map<string,MQO_OBJECT> objmap;
	bool frec;
	Button rec_start,rec_stop;

public:
	MyForm() :dib(640,480,24) ,rec_start("^") , rec_stop("~")
	{
		frec=false;

		text("QR test");
		size(800,600);
		fixsize(false);

		dib0.create(638,480);

		qrdib=DIBitmap(256,256);
		pic1.bitmap(qrdib);

		dib=DIBitmap(dib0.width,dib0.height);
		pic.bitmap(dib);

		bmp0.create(dib0.width,dib0.height);
		pic0.bitmap(bmp0);

		qrdib_tmp=DIBitmap(256,256);
		detector = new DetectQR(dib0.size());
		detector->settmp(dib,qrdib);

		add(pic0,0,0);
		add(pic,dib.width,0);
		add(pic1,32,dib.height+16);

		add(rec_start,500,dib.height+16);
		add(rec_stop);


		// OpenGL
		if(!gl.init(dib0.getdc())) {
			cout << "gl init ERROR" << endl;
		}

		// \ݒ
		glMatrixMode(GL_PROJECTION);
		//glLoadIdentity();
		//gluPerspective(60.0, 1.0, 2.0, 20.0);    //gluLookAt(2.0, 2.0, 2.0, 0.0, 0.0, 0.0, -0.5, 0.70, -0.5);
		argDrawMode3D();
		argDraw3dCamera( 0, 0 );

		glScalef(1.0,-1.0,1.0);
		glViewport(0, 0, (GLsizei)dib0.width,(GLsizei)dib0.height);


		GLfloat light_position[] = {300.0, -600.0, 500.0, 0.0};
		GLfloat light_diffuse[] = {1.0, 1.0, 1.0, 1.0};
		GLfloat light_ambient[]={0.3,0.3,0.3,0.0};

		glClearColor(0.0, 1.0, 1.0, 0.0);

		glEnable(GL_LIGHTING);
		glEnable(GL_LIGHT0);
		glEnable( GL_COLOR_MATERIAL );

		glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
		glLightfv(GL_LIGHT0, GL_POSITION, light_position);
		glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);

		GLfloat mat_specular[] = {1.0f, 1.0f, 1.0f, 1.0f};
		//	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_specular);

		//	glLightfv( GL_LIGHT0, GL_SPECULAR, light_specular );
		//	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_specular);
		//	glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, shininess);

		//	glColorMaterial(GL_FRONT_AND_BACK , GL_DIFFUSE);
		glEnable(GL_DEPTH_TEST);

		glEnable(GL_CULL_FACE);
		glCullFace(GL_BACK);

		objmap["LOADING"] = mqoCreateObject("model/nowloading.mqo", 0.5);
		objmap["NOTFOUND"] = mqoCreateObject("model/notfound.mqo", 0.5);

		// KɃ}bsO
		objmap["hachune.mqo"] = mqoCreateObject("model/miku_02.mqo", 0.3);

	}
	~MyForm(){
	}

	bool event(EventData &ev) {
		if (ev.message==WM_COMMAND) {
			if (LOWORD(ev.wp) == 1) {
				frec=true;
			} else if (LOWORD(ev.wp) == 2){
				frec=false;
			}
		}
		if (ev.message==WM_LBUTTONUP) {
			int x=(ev.lParam&0xffff) , y=(ev.lParam>>16);
			if (x<0 || y<0 || x>dib0.size().w ||y>dib0.size().h) return false;
		}
		return false;
	}


	// J摜ɃIuWFNgd˂
	void draw() {
		glMatrixMode(GL_MODELVIEW);
		glClear(GL_DEPTH_BUFFER_BIT);

		glRectd(-0.5,-0.5,0.5,0.5);


		//		glLoadIdentity();
//		GLfloat light_position[] = {300.0, -500.0, 500.0, 0.0};
//		glLightfv(GL_LIGHT0, GL_POSITION, light_position);
		for (uint i=0;i<objs.size();i++) {
			if (objs[i].fail_count>4) continue;
			glLoadIdentity();
			glTranslatef(0.0,-9.0,0.0); // ??
			glMultMatrixd(objs[i].mat);

			if (objs[i].str!="" && 0) {
				if (objs[i].frame_count>10) {
					string s=objs[i].str;
					if (objmap.count(s)) {
						mqoCallObject(objmap[s]);
					} else {
						glRotatef((objs[i].frame_count*20)%360,0,0,1.0);
						mqoCallObject(objmap["NOTFOUND"]);
					}
				} else {
					glRotatef((objs[i].frame_count*20)%360,0,0,1.0);
					mqoCallObject(objmap["LOADING"]);
				}
			} else {
				//glRotatef(-90,0,0,1.0);
				//mqoCallObject(objmap["hachune.mqo"]);
/*
				glColor3f(1.0, 1.0, 1.0);
				glBegin(GL_POLYGON); 
					glVertex3f( 40.0f,  40.0f, 0.0f); 
					glVertex3f( 40.0f, -40.0f, 0.0f); 
					glVertex3f(-40.0f, -40.0f, 0.0f); 
					glVertex3f(-40.0f,  40.0f, 0.0f); 
				glEnd();
*/				glColor3f(1.0, 1.0, -0.5);
				glPushMatrix();
				glRotatef((objs[i].frame_count*20)%360,0,0,1.0);
				glBegin(GL_POLYGON); 
					glVertex3f( 0.0f,  0.0f, 4.0f); 
					glVertex3f( 20.0f, 0.0f, 30.0f); 
					glVertex3f(-20.0f, 0.0f, 30.0f); 
				glEnd();
				glBegin(GL_POLYGON); 
					glVertex3f( 20.0f, 0.0f, 30.0f); 
					glVertex3f( 0.0f,  0.0f, 4.0f); 
					glVertex3f(-20.0f, 0.0f, 30.0f); 
				glEnd();
				glPopMatrix();
			}


		}

/*
		// ϊs̃eXg
		for (int i=0;i<obj_count;i++) {
			glLoadIdentity();
			glTranslatef(0.0,-9.0,0.0); // ??
			glMultMatrixf(mat[i]);
	GLfloat light_position[] = {-300.0, -500.0, 1000.0, 0.0};
	glLightfv(GL_LIGHT0, GL_POSITION, light_position);
			//glTranslatef(0.0,0.0,-8.0);
			glColor3f(1.0, 1.0, 1.0);
			glBegin(GL_POLYGON); 
			glVertex3f( 40.0f,  40.0f, 0.0f); 
			glVertex3f( 40.0f, -40.0f, 0.0f); 
			glVertex3f(-40.0f, -40.0f, 0.0f); 
			glVertex3f(-40.0f,  40.0f, 0.0f); 
			glEnd();
			glColor3f(1.0, 1.0, 0.0);

			glTranslatef(0.0,0.0,20.0);
			glutSolidCube(40.0);
		}
*/
		gl.draw();

		dib0.draw(bmp0);


		if (frec) {
			char fname[256];
			static int frame=1;
			sprintf(fname,"cap/frame%04d.bmp",frame++);
			dib0.save(fname);
		}
	}

	// ϊs쐬 (ARToolKitg)
	void mkmat(ARFloat m[16],const P vertex[4]){
		int i;

		// }[J[̒S
		P center=(vertex[0]+vertex[1]+vertex[2]+vertex[3])/4.0;

		ARMarkerInfo armi;
		armi.cf=0.99;
		armi.area=4800;
		armi.id=30;
		armi.dir=2;
		armi.pos[0]=center.real();
		armi.pos[1]=center.imag();
		for (i=0;i<4;i++) {
			P v = vertex[(i+1)%4]-vertex[i%4];
			if (v.real()<0)v=-v;
			v/=abs(v);
			armi.line[i][0]=v.imag();
			armi.line[i][1]=-v.real();
			armi.line[i][2]=-(v.imag()*vertex[(i)].real() - v.real()*vertex[(i)].imag());
//			printf("%lf %lf %lf\n",armi.line[i][0],armi.line[i][1],armi.line[i][2]);

		}

		double px,py,w1;
		for( i = 0; i < 4; i++ ) {
			w1 = armi.line[(i+3)%4][0] * armi.line[i][1] - armi.line[i][0] * armi.line[(i+3)%4][1];
			if( w1 == 0.0 ) break;
			px = (  armi.line[(i+3)%4][1] * armi.line[i][2]
					   - armi.line[i][1] * armi.line[(i+3)%4][2] ) / w1;
			py = (  armi.line[i][0] * armi.line[(i+3)%4][2]
					   - armi.line[(i+3)%4][0] * armi.line[i][2] ) / w1;
			//printf("%lf %lf\n",vertex[i].real(),vertex[i].imag());
			//printf(" %lf,%lf\n",px,py);
			armi.vertex[i][0]=px;
			armi.vertex[i][1]=py;
		}
		ARFloat cc[2]={0.0,0.0};
		double          patt_trans[3][4];
		arGetTransMat(&armi, cc, 80.0, patt_trans);
		argConvGlpara(patt_trans, m);

		//tracker->calcOpenGLMatrixFromMarker(&armi, cc, 80.0,m);
	}

	// QRR[hɎlp`Ԃ
	void hideqr(Bitmap &img, P vert[4]) {
		int x,y;
		Color c[4];
		P p=vert[0]+(vert[0]-vert[2])/20.0;
		c[0]=img.pixel(p.real(),p.imag())->value;

		for (y=0;y<256;y++) {
			P t1=(vert[0]*(double)(255-y)+vert[3]*(double)y) / 255.0;
			P t2=(vert[1]*(double)(255-y)+vert[2]*(double)y) / 255.0;
			t1.real(t1.real()+2);
			for (x=0;x<256;x++) {
				P p=(t1*(double)(255-x)+t2*(double)x) / 255.0;
				img.pixel(p.real(),p.imag())->value=c[0].rgba;
			}
		}
	}


	// QRR[hǂݎăIuWFNgɕRÂ
	void proc() {
		int i,j;
		obj_count=0;
		detector->detect(dib0);
		int oc=detector->count;

		P gp[40];
		int objno[40];
		P vert[4];
		for (i=0;i<oc;i++) {
			objno[i]=-1;
			detector->getVertex(vert,i);
			gp[i]=(vert[0]+vert[1]+vert[2]+vert[3])/4.0;
		}

		for (uint i=0;i<objs.size();i++) {
			objs[i].frame_count++;
			// ŏ̂
			double d,min=50.0; // e
			int id=-1;
			for (j=0;j<oc;j++) {
				if (objno[j]>=0) continue;
				d=abs(objs[i].g-gp[j]);
				if (d<min) {
					min=d;
					id=j;
				}
			}
			objs[i].matid=id;
			if (id>=0) {
				objs[i].fail_count = 0;
				objs[i].g = gp[id];
				objno[id]=i;
			} else {
				objs[i].fail_count++;
			}
		}
		for (i=0;i<oc;i++) {
			if (objno[i]<0) {
				objno[i]=objs.size();
				QROBJ t;
				t.g=gp[i];
				t.matid=i;
				objs.push_back(t);
			}
		}

		DCPen *pen=(DCPen*)dib.pen();
		pen->color(COLOR::white);

		string str;
		int err;
		for (i=0;i<oc;i++) {
			detector->getVertex(vert,i);
			mkmat(objs[objno[i]].mat,vert);

//*
			pen->color(COLOR::blue);
			pen->circlef(vert[0],3);
			pen->color(COLOR::yellow);
			pen->circlef(vert[1],3);
			pen->color(COLOR::cyan);
			pen->circlef(vert[2],3);
			pen->color(COLOR::green);
			pen->circlef(vert[3],3);
//*/
			pen->color(COLOR::green);
			for (j=0;j<3;j++) {
				dib.pixel(detector->cp[detector->pat[i*3+j]][0])->g=255;
				dib.pixel(detector->cp[detector->pat[i*3+j]][1])->g=255;
				dib.pixel(detector->cp[detector->pat[i*3+j]][2])->g=255;
				dib.pixel(detector->cp[detector->pat[i*3+j]][3])->g=255;
//				pen->line_(detector->cp[detector->pat[i*3+j]][0],detector->cp[detector->pat[i*3+j]][1] );
//				pen->line_(detector->cp[detector->pat[i*3+j]][1],detector->cp[detector->pat[i*3+j]][2] );
//				pen->line_(detector->cp[detector->pat[i*3+j]][2],detector->cp[detector->pat[i*3+j]][3] );
			}

			{
				int sz=detector->getCodeSize(i);
				Bitmap8 qr(sz,sz);
				detector->getCode(qr,i);
				err = decodeqr(str,qr);
				//hideqr(dib0,vert);
				if (err>=0) {
					cout << err << "  data:" << str << " ( "<< objs[objno[i]].str<< endl;
					if (objs[objno[i]].str!=str) {
						objs[objno[i]].str=str;
						objs[objno[i]].frame_count=0;
					}
					int sz=detector->getCodeSize(i);
				}
				/*	detector->getQRImage(qrdib,i);
					Pen *pp=qrdib.pen();
					for (j=0;j<sz;j++) {
						pp->line(0,256*j/sz,255,256*j/sz);
						pp->line(256*j/sz,0,256*j/sz,255);
					}
					pp->release();
				*/
			}
		}

		{
//			int sz=detector->getCodeSize(0);
//			Bitmap8 qr(sz,sz);
//			detector->getCode(qr,0);
		}

		vector<QROBJ> tmp;
		for (uint i=0;i<objs.size();i++) {
			if (objs[i].fail_count<10) {
				tmp.push_back(objs[i]);
			}
		}
		objs.swap(tmp);

		pen->release();
		obj_count=oc;

	}
};


int main(int argc, char** argv)
{

	// J擾
	Camera cam;
	IGraphBuilder *pGraph = cam.pGraph;
	
	IBaseFilter *pSrc = Camera::getSource();
	cam.pSrc = pSrc;
	if (pSrc == NULL) {
		cout << "video input device not found" << endl;
		return 0;
	}
	pGraph->AddFilter(pSrc, L"Video Capture");
	
	if (cam.init()==0) {
		cout << "connect error" << endl;
		return 0;
	}
	ISampleGrabber *pSGrab = cam.pSGrab;

	cam.start();
	Sleep(100);

	long *buffer = NULL;
	long bufsize = 0;
	// TCY擾
	do{
		pSGrab->GetCurrentBuffer(&bufsize, NULL);
		Sleep(1);
	}while(bufsize <= 0);

	buffer = (long *)malloc(sizeof(char)*bufsize);
	if(buffer==NULL){
		cerr << "can't allocate memory\n";
		return 1;
	}
	cerr << "bufsize : " << bufsize << endl;

	Bitmap *img = new Bitmap(buffer,cam.width,cam.height);


	// ARToolKit
	const char *cparam_name = "Data/camera_para.dat";
	ARParam		cparam;
	ARParam			wparam;
	if (arParamLoad(cparam_name, 1, &wparam) < 0) {
		fprintf(stderr, "setupCamera(): Error loading parameter file %s for camera.\n", cparam_name);
		return 1;
	}
	arParamChangeSize(&wparam, cam.width, cam.height, &cparam);
	fprintf(stdout, "*** Camera Parameter ***\n");
	arParamDisp(&cparam);


	MyForm myForm;
	myForm.show();
	while (myForm.isexist()) {
		if(!cam.cap(img)){
			cerr << "Capture error\n";
			break;
		}
		ImageFilter2::flip(*img);
		img->draw(myForm.dib0);

		myForm.proc();
		myForm.draw();
		myForm.update();
		wait(10);

	}
	return 0;
}
